/* Responsible for handling almost all the GEM functions for window
 * management. 
 * Called with 'report' being the Xevent structure with a button event
 * in it for a window somewhere...
 */

#include "gemx.h"

int checkWindowBits(int win, WORD *message)
	{

	if (report.xbutton.window == GEMwins[win].topBar)
		{
		if (GEMmakeActive(win) == 1)
			GEMmoveWindow(win);
		}

	else if (report.xbutton.window == GEMwins[win].client)
		{
		/* return SYSTEM so that the event will be passed to
		 * the client program
		 */
		GEMmessage(21,0,0,win,0,0,0,0,message);
		return SYSTEM;
		}

	if (win != GEMwinList[0])
		return;

	else if (report.xbutton.window == GEMwins[win].sidBar)
		{
		GEMmessage(24, 0,0,win,0,0,0,0,message);
		return SYSTEM;	
		}

	else if (report.xbutton.window == GEMwins[win].upArrow)
		{
		GEMmessage(24, 0,0,win,2,0,0,0,message);
		return SYSTEM;	
		}

	else if (report.xbutton.window == GEMwins[win].dnArrow)
		{
		GEMmessage(24, 0,0,win,3,0,0,0,message);
		return SYSTEM;	
		}

	else if (report.xbutton.window == GEMwins[win].closer)
		{
		GEMmessage(22, 0,0,win,0,0,0,0,message);
		return SYSTEM;				
		}

	else if (report.xbutton.window == GEMwins[win].fuller)
		{
		GEMmessage(23, 0,0,win,0,0,0,0,message);
		return SYSTEM;				
		}

	else if (report.xbutton.window == GEMwins[win].botBar)
		{
		GEMmessage(24, 0,0,win,5,0,0,0,message);
		return SYSTEM;				
		}

	else if (report.xbutton.window == GEMwins[win].ltArrow)
		{
		GEMmessage(24, 0,0,win,6,0,0,0,message);
		return SYSTEM;				
		}

	else if (report.xbutton.window == GEMwins[win].rtArrow)
		{
		GEMmessage(24, 0,0,win,7,0,0,0,message);
		return SYSTEM;
		}

	else if (report.xbutton.window == GEMwins[win].sizer)
		{
		GEMresizeWindow(win);
		GEMmessage(27,0,0,win,GEMwins[win].x, GEMwins[win].y,
				GEMwins[win].w, GEMwins[win].h, message);
		return SYSTEM;
		}

	return BORING;
	}
