/*
 * routines for making a window become the 'active' window
 */

#include "gemx.h"

int GEMmakeActive(int win)
	{
	int i,index;

	GEMuntopWindow(GEMwinList[0]);
	GEMtopWindow(win);

	if (GEMcountW == 0)
		{
		GEMwinList[0] = win;
		XMapRaised(display, GEMwins[win].win);
		}
	else if (GEMwinList[0] != win)
		{
		index = GEMgetWinIndex(win);
		for (i=0; i<index; i++)
			GEMwinList[i+1] = GEMwinList[i];
		GEMuntopWindow(GEMwinList[0]);
		GEMtopWindow(win);
		GEMwinList[0] = win;
		XMapRaised(display, GEMwins[win].win);
		}
	else
		{
		XEvent event;
		for(i=0; i<5000; i++)
			{
			usleep(500);
			if ( (XCheckWindowEvent(display, GEMwins[win].topBar,
						ButtonRelease, event)) == False)
				return 1;
			}
		index = GEMgetWinIndex(win);
		for (i=index; i<GEMcountW; i++)
			GEMwinList[i] = GEMwinList[i+1];
		GEMwinList[GEMcountW] = win;
		GEMuntopWindow(win);
		GEMtopWindow(GEMwinList[0]);
		XLowerWindow(display, GEMwins[win].win);
		}
	return 0;
	}


void GEMuntopWindow(int win)
	{
	XSetWindowBackgroundPixmap(display, GEMwins[win].topBar, GEMwhite);
	XClearWindow(display, GEMwins[win].topBar);
	}

void GEMtopWindow(int win)
	{
	XSetWindowBackgroundPixmap(display, GEMwins[win].topBar, GEMPatFl[2]);
	XClearWindow(display, GEMwins[win].topBar);
	}

int GEMgetWinIndex(int win)
	{
	int i;

	for (i=0; i<=GEMcountW; i++)
		if (GEMwinList[i] == win)
			return i;

	fprintf(stderr, "Could not find window in list\n");
	}
