/*
 * prototypes for the various callable routines in Gem-X
 */

#ifndef WORD
#define WORD short
#endif

#ifndef LONG
#define LONG long
#endif

#ifndef BYTE 
#define BYTE char
#endif

/* Window-related functions (in wind.c)									*/
WORD wind_create(LONG Parts, WORD Wx, WORD Wy, WORD Ww, WORD Wh);
WORD wind_open(int Handle, WORD x, WORD y, WORD w, WORD h);

/* Application-related functions (in appl.c)							*/
WORD appl_init();
WORD appl_exit();

/* Event-related functions (in event.c)									*/
WORD evnt_multi(WORD Type, WORD Clicks, WORD WhichButton,WORD WhichState,
				    WORD EnterExit1, WORD In1X,WORD In1Y,WORD In1W,WORD In1H, 
				    WORD EnterExit2, WORD In2X,WORD In2Y,WORD In2W,WORD In2H,
				    WORD MesagBuf[],  unsigned LONG Interval,
				    WORD *OutX, WORD *OutY,
				    WORD *ButtonState, WORD *KeyState, WORD *Key,
				    WORD *ReturnCount);
int redrawWindowBits(int win, Window theWin);
void GEMresizeWindow(int win);
void GEMdoResize(int win, int newW, int newH);
int GEMmakeActive(int win);
void GEMtopWindow(int win);
void GEMuntopWindow(int win);
void GEMmoveWindow(int win);
void GEMdoMoveWindow(int win, WORD x, WORD y);
void GEMmessage(WORD x1, WORD x2, WORD x3, WORD x4,
				WORD x5, WORD x6, WORD x7, WORD x8, WORD *buffer);

/* graf-related functions (in graf.c)									*/
WORD graf_rubberbox(WORD x, WORD y, WORD w, WORD h, WORD *oW, WORD *oH);
graf_dragbox(WORD sW, WORD sH, WORD sX, WORD sY,
			 WORD bX, WORD bY, WORD bW, WORD bH,
			 WORD *fX, WORD *fY);


/* VDI-related prototypes(in vdi.c)										*/
WORD vswr_mode(WORD handle, WORD mode);
void vs_color(WORD handle, WORD index, WORD *rgb);
WORD vsl_type(WORD handle, WORD style);
void vsl_udsty(WORD handle, WORD pattern);
WORD vsl_width(WORD handle, WORD width);
WORD vsl_color(int handle, int colour);
void vsl_ends(WORD handle, WORD start, WORD end);
WORD vsm_type(WORD handle, WORD symbol);
void vsm_height(WORD handle, WORD height);
WORD vsm_color(WORD handle, WORD index);
WORD vst_height(WORD handle, WORD height, WORD *charW, WORD *charH, 
				WORD *cellW, WORD *cellH);
WORD vst_point(WORD handle, WORD point, WORD *charw, WORD *charh,
			   WORD *cellw, WORD *cellh);
WORD vst_effects(WORD handle, WORD effects);
void vst_alignment(WORD handle, WORD hin, WORD vin, WORD *hout, WORD *vout);
WORD vsf_interior(WORD handle, WORD style);
WORD vsf_fill(WORD handle, WORD style);
WORD vsf_style(WORD handle, WORD style);
WORD vsf_color(WORD handle, WORD index);
WORD vsf_perimeter(WORD handle, WORD visible);
void vsf_udpat(WORD handle, WORD pat[], WORD planes);
void v_opnwk(WORD work_in[], WORD *handle, WORD work_out[]);
void v_clswk(WORD handle);
void v_opvnwk(WORD work_in[], WORD *handle, WORD work_out[]);
void v_clswk(WORD handle);
WORD vst_load_fonts(WORD handle, WORD select);
void vst_unload_fonts(WORD handle, WORD select);
void pxytoXRect(WORD *array, XRectangle *rect);
void vs_clip(WORD handle, WORD flag, WORD pxyarray[]);






