/*
 * routine to redraw what's on the desktop that GEM normally redraws
 */

#include "gemx.h"
#define DEBUG 0

int redrawWindowBits(int win, Window theWin)
	{
	/* redraw the 'bits' of the GEM windows - ie: all the subwindows apart
	 * from the client subwindow for each parent
	 */

	if (theWin == GEMwins[win].topBar)
		{
		if (DEBUG) printf("redrawing topbar\n");
		}

	else if (theWin == GEMwins[win].infoBar)
		{
		if (DEBUG) printf("redrawing infobar\n");
		}

	else if (theWin == GEMwins[win].sidBar)
		{
		if (DEBUG) printf("redrawing sidebar\n");
		}

	else if (theWin == GEMwins[win].upArrow)
		{
		if (DEBUG) printf("redrawing uparrow\n");
		XCopyArea(display, GEMarrU, GEMwins[win].upArrow, gc[0], 0,0,16,16,2,2);
		}

	else if (theWin == GEMwins[win].dnArrow)
		{
		if (DEBUG) printf("redrawing down arrow\n");
		XCopyArea(display, GEMarrD, GEMwins[win].dnArrow, gc[0], 0,0,16,16,2,2);
		}

	else if (theWin == GEMwins[win].closer)
		{
		if (DEBUG) printf("redrawing closer\n");
		XCopyArea(display, GEMclose, GEMwins[win].closer, gc[0], 0,0,16,16,2,2);
		}

	else if (theWin == GEMwins[win].fuller)
		{
		if (DEBUG) printf("redrawing fuller\n");
		XCopyArea(display, GEMfull, GEMwins[win].fuller, gc[0], 0,0,16,16,2,2);
		}

	else if (theWin == GEMwins[win].botBar)
		{
		if (DEBUG) printf("redrawing botbar\n");
		}

	else if (theWin == GEMwins[win].ltArrow)
		{
		if (DEBUG) printf("redrawing left arrow\n");
		XCopyArea(display, GEMarrL, GEMwins[win].ltArrow, gc[0], 0,0,16,16,2,2);
		}

	else if (theWin == GEMwins[win].rtArrow)
		{
		if (DEBUG) printf("redrawing right arrow\n");
		XCopyArea(display, GEMarrR, GEMwins[win].rtArrow, gc[0], 0,0,16,16,2,2);
		}

	else if (theWin == GEMwins[win].sizer)
		{
		if (DEBUG) printf("redrawing sizer\n");
		XCopyArea(display, GEMsize, GEMwins[win].sizer, gc[0], 0,0,16,16,2,2);
		}

	else if (theWin == GEMwins[win].client)
		{
		return CLIENT;
		}

	return 0;
	}
