/* definitions to do with GEM resource files
 */

#ifndef __GEM_RESOURCE_H
#define __GEM_RESOURCE_H

#include "gemfast.h"

#define ERRCODE -1
#define BYTESWAP 1

#define READ_OK 0
#define READ_BAD 1

short rsrc_load(char *rsc);

typedef unsigned short ushort;

typedef struct GEMrsrc
	{
	ushort vrsn;			/* version number								*/
	ushort object;			/* offset to OBJECT structures					*/
	ushort tedinfo;			/* offset to TEDINFO structures					*/
	ushort iconblk;			/* offset to ICONBLK structures					*/
	ushort bitblk;			/* offset to BITBLK structures					*/
	ushort frstr;			/* offset to string pointer table				*/
	ushort string;			/* offset to string data						*/
	ushort imdata;			/* offset to image data							*/
	ushort frimg;			/* offset to image pointer table				*/
	ushort trindex;			/* offset to tree pointer table					*/
	ushort nobs;			/* number of OBJECTs in the resource			*/
	ushort ntree;			/* number of object trees						*/
	ushort nted;			/* number of TEDINFOs							*/
	ushort nib;				/* number of ICONBLKs							*/
	ushort nbb;				/* number of BITBLKs							*/
	ushort nstring;			/* number of free strings						*/
	ushort nimages;			/* number of free images						*/
	ushort rssize;			/* size of resource								*/

	OBJECT *obj;			/* internal object array						*/
	TEDINFO *ted;			/* internal tedinfo array						*/
	ICONBLK *icon;			/* internal iconblk array						*/
	BITBLK *blk;			/* internal bitblock array						*/
	char **str;				/* internal string data array					*/
	BITBLK *fimg;			/* internal array of free images				*/
	} GEMrsrc;


#endif /* __GEM_RESOURCE_H */
