/* Routines to load a GEM resource file										*/

#include <stdio.h>
#include "GEMrsc.h"


static GEMrsrc theRsc;			/* the Resource structure					*/

void dispRsc(void)
	{
	GEMrsrc rsc;

	rsc = theRsc;
	fprintf(stderr, "Resource file values are:\n");
	fprintf(stderr, "versn:   %u\n", rsc.vrsn);
	fprintf(stderr, "object:  %u\n", rsc.object);
	fprintf(stderr, "tedinfo: %u\n", rsc.tedinfo);
	fprintf(stderr, "iconblk: %u\n", rsc.iconblk);
	fprintf(stderr, "bitblk:  %u\n", rsc.bitblk);
	fprintf(stderr, "frstr:   %u\n", rsc.frstr);
	fprintf(stderr, "string:  %u\n", rsc.string);
	fprintf(stderr, "imdata:  %u\n", rsc.imdata);
	fprintf(stderr, "frimg:   %u\n", rsc.frimg);
	fprintf(stderr, "trindex: %u\n", rsc.trindex);
	fprintf(stderr, "nobs:    %u\n", rsc.nobs);
	fprintf(stderr, "ntree:   %u\n", rsc.ntree);
	fprintf(stderr, "nted:    %u\n", rsc.nted);
	fprintf(stderr, "nib:     %u\n", rsc.nib);
	fprintf(stderr, "nbb:     %u\n", rsc.nbb);
	fprintf(stderr, "nstring: %u\n", rsc.nstring);
	fprintf(stderr, "nimages: %u\n", rsc.nimages);
	fprintf(stderr, "rssize:  %u\n\n\n", rsc.rssize);
	}	


void GEMbyteswap(ushort *val)
	{
	unsigned char top, bottom;

	bottom = (*val) & 255;
	top = (*val) >> 8;
	*val = bottom * 256 + top;
	}


short rsrc_load(char *rsc)
	{
	FILE *fp;				/* Used to read in the resource					*/
	int flag;				/* Used to check the read went ok				*/
	int i,j,k;				/* loop vars									*/

	if ( (fp = fopen(rsc, "rb")) == NULL)
		return ERRCODE;

	flag = READ_OK;
	if ((fread(&(theRsc.vrsn), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.object), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.tedinfo), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.iconblk), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.bitblk), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.frstr), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.string), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.imdata), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.frimg), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.trindex), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.nobs), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.ntree), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.nted), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.nib), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.nbb), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.nstring), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.nimages), 2, 1, fp)) != 1) flag =READ_BAD;
	if ((fread(&(theRsc.rssize), 2, 1, fp)) != 1) flag =READ_BAD;
	
	if (flag != READ_OK)
		{
		perror("Error reading RSC file");
		return ERRCODE;
		}

	if (BYTESWAP)
		{
		GEMbyteswap(&(theRsc.vrsn));
		GEMbyteswap(&(theRsc.object));
		GEMbyteswap(&(theRsc.tedinfo));
		GEMbyteswap(&(theRsc.iconblk));
		GEMbyteswap(&(theRsc.bitblk));
		GEMbyteswap(&(theRsc.frstr));
		GEMbyteswap(&(theRsc.string));
		GEMbyteswap(&(theRsc.imdata));
		GEMbyteswap(&(theRsc.frimg));
		GEMbyteswap(&(theRsc.trindex));
		GEMbyteswap(&(theRsc.nobs));
		GEMbyteswap(&(theRsc.ntree));
		GEMbyteswap(&(theRsc.nted));
		GEMbyteswap(&(theRsc.nib));
		GEMbyteswap(&(theRsc.nbb));
		GEMbyteswap(&(theRsc.nstring));
		GEMbyteswap(&(theRsc.nimages));
		GEMbyteswap(&(theRsc.rssize));
		}
	dispRsc();

	/* So now we have a RSC file in our native format					*/
	/* Allocate memory for the number of structures we need				*/

	if (theRsc.nobs != 0)
		if ((theRsc.obj = (OBJECT *) calloc
								(theRsc.nobs, sizeof(OBJECT))) == NULL)
			{
			perror("Unable to calloc OBJECT memory");
			return ERRCODE;
			}
	if (theRsc.nted != 0)
		if ((theRsc.ted = (TEDINFO*) calloc
								(theRsc.nted, sizeof(TEDINFO))) == NULL)
			{
			perror("Unable to calloc TEDINFO memory");
			return ERRCODE;
			}
	if (theRsc.nib != 0)
		if ((theRsc.icon =(ICONBLK*) calloc
								(theRsc.nib, sizeof(ICONBLK))) == NULL)
			{
			perror("Unable to calloc ICONBLK memory");
			return ERRCODE;
			}
	if (theRsc.nbb != 0)
		if ((theRsc.blk =(BITBLK*) calloc
								(theRsc.nbb, sizeof(BITBLK))) == NULL)
			{
			perror("Unable to calloc BITBLK memory");
			return ERRCODE;
			}
	if (theRsc.nstring != 0)
		if ((theRsc.str =(char **) calloc
								(theRsc.nstring, sizeof(char *))) == NULL)
			{
			perror("Unable to calloc STRING memory");
			return ERRCODE;
			}
	if (theRsc.nimages != 0)
		if ((theRsc.fimg =(BITBLK *) calloc
								(theRsc.nimages, sizeof(BITBLK))) == NULL)
			{
			perror("Unable to calloc FREEIMAGE memory");
			return ERRCODE;
			}

	/* Now read in the various elements of a resource file...			*/
	/* 1. OBJECT structures...											*/

	fseek(fp, theRsc.object, SEEK_SET);
	if ((fread(theRsc.obj, sizeof(OBJECT), theRsc.nobs, fp)) != theRsc.nobs)
		{
		perror("Cannot load the OBJECT data");
		return ERRCODE;
		}

	/* 2. TEDINFO structures											*/
	fseek(fp, theRsc.tedinfo, SEEK_SET);
	if ((fread(theRsc.ted, sizeof(TEDINFO), theRsc.nted, fp)) != theRsc.nted)
		{
		perror("Cannot load the TEDINFO data");
		return ERRCODE;
		}

	/* 3. ICONBLK structures											*/
	fseek(fp, theRsc.iconblk, SEEK_SET);
	if ((fread(theRsc.icon, sizeof(ICONBLK), theRsc.nib, fp)) != theRsc.nib)
		{
		perror("Cannot load the ICONBLK data");
		return ERRCODE;
		}

	/* 4. BITBLK structures												*/
	fseek(fp, theRsc.bitblk, SEEK_SET);
	if ((fread(theRsc.blk, sizeof(BITBLK), theRsc.nbb, fp)) != theRsc.nbb)
		{
		perror("Cannot load the ICONBLK data");
		return ERRCODE;
		}

	/* 5. Free strings													*/
		{
		char buffer[65535];			/* Large enough for larges poss str	*/
		long *off;					/* Table of string offsets			*/

		if ((off = (long *)calloc(theRsc.nstring, 4)) == NULL)
			{
			perror("Can't reserve buffer memory for string table");
			return ERRCODE;
			}

		/* Read in the table of string offsets							*/
		fseek(fp, theRsc.frstr, SEEK_SET);
		if ((fread(off, sizeof(long), theRsc.nstring, fp)) != theRsc.nstring)
			{
			perror("Can't read in string table");
			return ERRCODE;
			}

		/* Now read in each string										*/
		for (i=0; i< theRsc.nstring; i++)
			{
			fseek(fp, off[i], SEEK_SET);
			if ( (fgets(buffer, 65535, fp)) == NULL)
				{
				perror("Can't read in string data");
				return ERRCODE;
				}
			if ((theRsc.str[i] = (char *) calloc(strlen(buffer)+1, 1)) == NULL)
				{
				perror("Can't reserve string memory");
				return ERRCODE;
				}
			strcpy(theRsc.str[i], buffer);
			}
		free(off);
		}
			
	/* 6. Free images													*/
		{
		char *buffer[65535];
		long *off;

		if ((off = (long *)calloc(theRsc.nimages, 4)) == NULL)
			{
			perror("Can't reserve buffer memory for image table");
			return ERRCODE;
			}

		/* Read in the table of image offsets							*/
		fseek(fp, theRsc.frimg, SEEK_SET);
		if ((fread(off, sizeof(long), theRsc.nimages, fp)) != theRsc.nimages)
			{
			perror("Can't read in image table");
			return ERRCODE;
			}

		/* Now read in each image										*/
		for (i=0; i< theRsc.nimages; i++)
			{
			fseek(fp, off[i], SEEK_SET);

			fprintf(stderr, "Failed to read image %d\n", i);
			}
		free(off);
		}


	/* Now we must cycle over the various elements of the rsc file and
	 * adjust the values to point to the real data, and not indices
	 */
	for (i=0; i< theRsc.nobs; i++)
		{
		switch (theRsc.obj[i].ob_type)
			{
			case G_TEXT:
				theRsc.obj[i].ob_spec = &(theRsc.ted[theRsc.obj[i].ob_spec]);
				break;

			case G_BOXTEXT:
				theRsc.obj[i].ob_spec = &(theRsc.ted[theRsc.obj[i].ob_spec]);
				break;

/*			case G_IMAGE:
				theRsc.obj[i].ob_spec = &(theRsc.*/
			}
		}
	}


int main(int argc, char **argv)
	{
	if (argc>1)
		rsrc_load(argv[1]);
	dispRsc();
	
	}
