/* Implements the Virtual Device Interface for the X version of GEM.	*/
#define VDI_LOCAL 1

#include "GEMvdi.h"

WORD vswr_mode(WORD handle, WORD mode)
	{
	/* sets the graphics writing mode for the vdi workstation (GC)
	 * NOTE: this depends on the ordering of function modes being the
	 *       same under X as it is in GEM. This is the case for my setup.
	 */

	if (GCmap[handle] != 0)
		{
		XSetFunction(display,gc[handle], mode);
		return VDISUCCESS;
		}
	else
		return VDIFAIL;
 	}

void vs_color(WORD handle, WORD index, WORD *rgb)
	{
	/* BUG: needs fixing for colour										*/
	/* sets the color for a given index									*/
	}

WORD vsl_type(WORD handle, WORD style)
	{
	/* sets the line type in this workstation							*/
	char dashes[10];

	if (GCmap[handle] == 0)
		return VDIFAIL;

	switch(style)
		{
		case 0:
			GCdash[handle] = LineSolid;
			XSetLineAttributes(display, gc[handle],GCwid[handle],
				LineSolid, GCend[handle], JoinBevel);
			return VDISUCCESS;
			break;
		case 1:
			{
			dashes[0] = 4;
			dashes[1] = 2;
			GCdash[handle] = LineOnOffDash;
			XSetLineAttributes(display, gc[handle],GCwid[handle],
				LineOnOffDash, GCend[handle], JoinBevel);
			XSetDashes(display, gc[handle], 0, dashes, 2);
			return VDISUCCESS;
			break;
			}
		case 2:
			{
			dashes[0] = 1;
			dashes[1] = 4;
			GCdash[handle] = LineOnOffDash;
			XSetLineAttributes(display, gc[handle],GCwid[handle],
				LineOnOffDash, GCend[handle], JoinBevel);
			XSetDashes(display, gc[handle], 0, dashes, 2);
			return VDISUCCESS;
			break;
			}
		case 3:
			{
			dashes[0] = 4;
			dashes[1] = 2;
			dashes[2] = 1;
			dashes[3] = 2;
			GCdash[handle] = LineOnOffDash;
			XSetLineAttributes(display, gc[handle],GCwid[handle],
				LineOnOffDash, GCend[handle], JoinBevel);
			XSetDashes(display, gc[handle], 0, dashes, 4);
			return VDISUCCESS;
			break;
			}
		case 4:
			{
			dashes[0] = 4;
			dashes[1] = 4;
			GCdash[handle] = LineOnOffDash;
			XSetLineAttributes(display, gc[handle],GCwid[handle],
				LineOnOffDash, GCend[handle], JoinBevel);
			XSetDashes(display, gc[handle], 0, dashes, 2);
			return VDISUCCESS;
			break;
			}
		case 5:
			{
			dashes[0] = 2;
			dashes[1] = 2;
			dashes[2] = 1;
			dashes[3] = 1;
			dashes[4] = 1;
			dashes[5] = 2;
			GCdash[handle] = LineOnOffDash;
			XSetLineAttributes(display, gc[handle],GCwid[handle],
				LineOnOffDash, GCend[handle], JoinBevel);
			XSetDashes(display, gc[handle], 0, dashes, 6);
			return VDISUCCESS;
			break;
			}
		}
	return VDIFAIL;
	}

void vsl_udsty(WORD handle, WORD pattern)
	{
	/* BUG: needs fixing to take a user-defined pattern					*/
	vsl_type(handle, 0);
	}

WORD vsl_width(WORD handle, WORD width)
	{
	/* sets the width of the drawing line								*/
	if (GCmap[handle] == 0)
		return VDIFAIL;

	GCwid[handle]  =width;
	XSetLineAttributes(display, gc[handle],GCwid[handle],
		GCdash[handle], GCend[handle], JoinBevel);
	return VDISUCCESS;
	}

WORD vsl_color(int handle, int colour)
	{
	/* sets the foreground colour										*/
	if (GCmap[handle] == 0)
		return VDIFAIL;

	if (BLACKWHITE)
		{
		switch (colour)
			{
			case 0:
				XSetForeground(display, gc[handle],
					WhitePixel(display, screen_num));
				break;
			case 1:
				XSetForeground(display, gc[handle],
					BlackPixel(display, screen_num));
				break;
			}
		return VDISUCCESS;
		}
	return VDISUCCESS;
	}

void vsl_ends(WORD handle, WORD start, WORD end)
	{
	/* sets the ends of the lines to be whatever.
	 * BUG: the end and start are currently identical
	 * BUG: arrows not yet implemented
	 */

	if (GCmap[handle] != 0)
		{
		switch(start)
			{
			case 0:
				GCend[handle] = CapButt;
				XSetLineAttributes(display, gc[handle], GCwid[handle],
					GCdash[handle],GCend[handle], JoinBevel);
				break;

			case 1:
				GCend[handle] = CapRound;
				XSetLineAttributes(display, gc[handle], GCwid[handle],
					GCdash[handle],GCend[handle], JoinBevel);
				break;

			case 2:
				GCend[handle] = CapButt;
				XSetLineAttributes(display, gc[handle], GCwid[handle],
					GCdash[handle],GCend[handle], JoinBevel);
				break;
			}
		}
	}

WORD vsm_type(WORD handle, WORD symbol)
	{
	/* BUG: vsm_type not yet implemented								*/
	return VDIFAIL;
	}

void vsm_height(WORD handle, WORD height)
	{
	/* BUG: vsm_height not yet implemented								*/
	}

WORD vsm_color(WORD handle, WORD index)
	{
	/* BUG: vsm_color not yet implemented								*/
	return VDIFAIL;
	}

WORD vst_height(WORD handle, WORD height, WORD *charW, WORD *charH, 
				WORD *cellW, WORD *cellH)
	{
	/* BUG: vst_height not yet implemented								*/
	return VDIFAIL;
	}

WORD vst_point(WORD handle, WORD point, WORD *charw, WORD *charh,
			   WORD *cellw, WORD *cellh)
	{
	/* BUG: vst_point not yet implemented								*/
	return VDIFAIL;
	}

WORD vst_effects(WORD handle, WORD effects)
	{
	/* BUG: vst_effects not yet implemented								*/
	return VDIFAIL;
	}

void vst_alignment(WORD handle, WORD hin, WORD vin, WORD *hout, WORD *vout)
	{
	/* BUG: vst_alignment not yet implemented							*/
	}

WORD vsf_interior(WORD handle, WORD style)
	{
	/* BUG: vsf_interior not yet implemented							*/
	return VDIFAIL;
	}

WORD vsf_fill(WORD handle, WORD style)
	{
	if (GCmap[handle] != 0)
		{
		XSetTile(display, gc[handle], GEMPatFl[style]);
		return VDISUCCESS;
		}

	return VDIFAIL;
	}

WORD vsf_style(WORD handle, WORD style)
	{
	/* BUG: vsf_style not yet implemented								*/
	return VDIFAIL;
	}

WORD vsf_color(WORD handle, WORD index)
	{
	if (GCmap[handle] != 0)
		if (BLACKWHITE)
			{
			if (index == 0)
				XSetForeground(display, gc[handle],
						WhitePixel(display, screen_num));
			else
				XSetForeground(display, gc[handle],
						BlackPixel(display, screen_num));
			return VDISUCCESS;
			}
	return VDIFAIL;
	}

WORD vsf_perimeter(WORD handle, WORD visible)
	{
	if (GCmap[handle] != 0)
		{
		GCperim[handle] = visible;
		return VDISUCCESS;
		}
	return VDIFAIL;
	}

void vsf_udpat(WORD handle, WORD pat[], WORD planes)
	{
	/* BUG: vsf_udpat not yet implemented								*/
	}

void v_opnvwk(WORD work_in[], WORD *handle, WORD work_out[])
	{
	/* Open the Virtual workstation. Sets up a graphics context...		*/

	unsigned long valueMask =0;
	XGCValues values;

	*handle = ++GEMwks;

	gc[GEMwks] = XCreateGC(display,  GEMDesk, valueMask, values);
	GCmap[GEMwks] =1;

	/* Now fill out the work_out array									*/
	work_out[0] = GEMDeskW-1;
	work_out[1] = GEMDeskH-1;
	}

void v_opnwk(WORD work_in[], WORD *handle, WORD work_out[])
	{
	/* call a virtual workstation instead :-)							*/
	v_opnvwk(work_in, handle, work_out);
	}


void v_clsvwk(WORD handle)
	{
	if (GCmap[handle] == 1)
		{
		XFreeGC(display, gc[handle]);
		GCmap[handle] =0;
		}
	}

void v_clswk(WORD handle)
	{
	/* call the virtual close instead :-)								*/
	v_clsvwk(handle);
	}

WORD vst_load_fonts(WORD handle, WORD select)
	{
	/* BUG: vst_load_fonts not yet implemented							*/
	return VDIFAIL;
	}

void vst_unload_fonts(WORD handle, WORD select)
	{
	/* BUG: vst_unload_fonts doesn't work								*/
	}

void pxytoXRect(WORD *array, XRectangle *rect)
	{
	rect->x		 = array[0];
	rect->y		 = array[1];
	rect->width  = array[2] - array[0];
	rect->height = array[3] - array[1];
	}

void vs_clip(WORD handle, WORD flag, WORD pxyarray[])
	{
	XRectangle area;

	if (GCmap[handle] == 1)
		{
		if (flag == 0)
			{
			/* disable clipping rectangle								*/
			XSetClipMask(display, gc[handle], None);
			}
		else
			{
			/* Set the rectangle clip to the given co-ords				*/
			pxytoXRect(pxyarray, &area);
			XSetClipRectangles(display, gc[handle], 0,0, &area, 1, Unsorted);
			}
		}
	}

/* void v_bar(WORD handle, WORD pxyarray)
	{
	if (GCmap[handle] == 1)
		{
		XDrawRectangle(display, */
