/*
 * header file for the application library routines
 *
 */
#ifndef __APPL_H
#define __APPL_H

#ifndef TRUE
#define TRUE 1
#endif

short appl_init();
short appl_exit();

#ifndef forever
#define forever for(;;)
#endif


/* Global variables 													*/
#ifndef __APPL_H_GLOBALS
#define AWHERE extern
extern char *GEMXDIR;
extern char *GEMXLIB;
#else
#define AWHERE
char *GEMXDIR = "/tmp/Gem-X";
char *GEMXLIB = "/home/phlem/sjg/st/gemX/bitmaps";
#endif

#ifndef WORD
#define WORD short
#endif

#ifndef SLIDSZ
#define SLIDSZ 20
#endif

#ifndef CLIENT
#define CLIENT 1
#endif
#ifndef SYSTEM
#define SYSTEM 2
#endif
#ifndef BORING
#define BORING 0
#endif

AWHERE int GEMapId;				/* GEM application id					*/
AWHERE int GEMdp;				/* depth of the GEM display				*/
AWHERE int GEMht;				/* height of the GEM display			*/
AWHERE int GEMwd;				/* width of the GEM display				*/
AWHERE int GEMactive;			/* the active GEM window				*/

#ifndef GEMworks
#define GEMworks 10				/* Number of concurrent workstations	*/
#endif
AWHERE XEvent report;			/* the X event used by the dispatcher	*/
AWHERE Display *display;		/* An X display							*/
AWHERE int screen_num;			/* The number of the screen (!)			*/
AWHERE Visual *visual;			/* Reference visual for X				*/
AWHERE GC gc[GEMworks];			/* graphics context(s)					*/
AWHERE char GCmap[GEMworks];	/* flags to say which GC's are used		*/
AWHERE WORD GCwid[GEMworks];	/* the linewidths for the gc			*/
AWHERE WORD GCend[GEMworks];	/* the line-ends for the GC				*/
AWHERE WORD GCdash[GEMworks];	/* the dash-pattern flag for the GC		*/
AWHERE WORD GCperim[GEMworks];	/* whether to draw box perimeters		*/
AWHERE int GEMwks;				/* how many vdi workstations we have	*/

AWHERE Window GEMDesk;			/* the GEM desktop X window				*/
AWHERE Pixmap GEMBack;			/* the GEM desktop background			*/
AWHERE Pixmap GEMIcon;			/* The GEM icon bitmap					*/
AWHERE Pixmap GEMarrU;			/* the up-arrow bitmap					*/
AWHERE Pixmap GEMarrD;			/* the down-arrow bitmap				*/
AWHERE Pixmap GEMarrL;			/* the left-arrow bitmap				*/
AWHERE Pixmap GEMarrR;			/* the right-arrow bitmap				*/
AWHERE Pixmap GEMclose;			/* the closer bitmap					*/
AWHERE Pixmap GEMfull;			/* the fuller bitmap					*/
AWHERE Pixmap GEMsize;			/* the resizing bitmap					*/
AWHERE Pixmap GEMwhite;			/* a white area - no pattern			*/

AWHERE Pixmap GEMPatFl[25];		/* Pattern fill bitmaps					*/
AWHERE Pixmap GEMLinFl[13];		/* Line fill bitmaps					*/

AWHERE int GEMDeskW, GEMDeskH;	/* the GEM desktop width & height		*/

#endif /* __APPL_H */
