/*
 * An X-event to GEM-event conversion library.
 */

#include "gemx.h"

/* prototypes of private functions											*/
void GEMDeskRedraw(int X, int Y, int W, int H);

#define DEBUG 1

WORD evnt_multi(WORD Type, WORD Clicks, WORD WhichButton,
				    WORD WhichState, WORD EnterExit1, WORD In1X,
				    WORD In1Y, WORD In1W, WORD In1H,
				    WORD EnterExit2, WORD In2X, 
				    WORD In2Y, WORD In2W, WORD In2H,
				    WORD MesagBuf[],  unsigned LONG Interval,
				    WORD *OutX, WORD *OutY,
				    WORD *ButtonState, WORD *KeyState, WORD *Key,
				    WORD *ReturnCount)

	{
	/* This routine sits here waiting in the X event loop until a
	 * GEM-like event comes along, at which point it will return
	 * the correct GEM message to the calling program
	 */
	int fallout = 0;

	while (fallout == 0)
		{
		Window theWin;
		int theX, theY, theW, theH;
		int theBtn, theXc, theYc;

		int i,j,k;
		WORD d1, d2;

		XNextEvent(display, &report);

		theWin  = report.xexpose.window;
		theX = report.xexpose.x;
		theY = report.xexpose.y;
		theW = report.xexpose.width;
		theH = report.xexpose.height;

		theBtn = report.xbutton.button;
		theXc =  report.xbutton.x;
		theYc =  report.xbutton.y;

		switch (report.type)
			{
			case Expose:
				{
				/* Send a GEM message down the GEMtube to the application
				 * because we need to draw part of the window. First make
				 * sure it's not part of the window that the system is
				 * responsible for ...
				 */
				if (theWin == GEMDesk)
					{
					/* It's our responsibility. Redraw the desktop.			*/
					GEMDeskRedraw(theX, theY, theW, theH);
					}

				/* GEM takes care of the sliders, top etc...				*/
				for (i=0; i<=GEMcountW; i++)
					{
					if (redrawWindowBits(i, theWin) == CLIENT)
						{
						GEMmessage(WM_REDRAW, 0, 0, i,
							theX, theY, theW, theH, MesagBuf);
						fallout =1;
						}
					}

				break;
				}

			case ConfigureNotify:
				{
				/* Either the desktop has been resized 
				 * or the user has resized a subwindow.
				 */
				if (theWin == GEMDesk)
					{
					GEMDeskW = report.xconfigure.width;
					GEMDeskH = report.xconfigure.height;
					}
				break;
				}

			case ButtonPress:
				{
				/* Search to see if the button press is in any of the
				 * areas which we control. If it isn't then pass it on to
				 * the client application.
				 */
				
				/* Check window bits of the child windows				*/
				for (i=0; i<=GEMcountW; i++)
						fallout += checkWindowBits(i, MesagBuf);				

				break;
				}

			case KeyPress:
				{
				appl_exit();
				break;
				}

			default:
				{
				break;
				}
			}
		
		}
	}


void GEMDeskRedraw(int X, int Y, int W, int H)
	{
	/* redraw a part of the desktop. This will eventually have to redraw object
	 * trees - but for now it just plonks a bitmap into the window.
	 */
 
	XClearArea(display, GEMDesk, X, Y, W, H, TRUE);
	}
 
void GEMmessage(WORD x1, WORD x2, WORD x3, WORD x4,
				WORD x5, WORD x6, WORD x7, WORD x8, WORD *buffer)
	{
	/* Creates a GEM message buffer containing the values x{1-8}		*/

	buffer[0] = x1;
	buffer[1] = x2;
	buffer[2] = x3;
	buffer[3] = x4;
	buffer[4] = x5;
	buffer[5] = x6;
	buffer[6] = x7;
	buffer[7] = x8;
	}
