/*
 * wind.h - header file for all the wind.c library routines
 */
#ifndef __WIND_H
#define __WIND_H

#include "appl.h"

#ifndef __WIND_H_GLOBALS
#define WWHERE extern
#else
#define WWHERE
#endif

#ifndef WORD
#define WORD short
#endif

#ifndef SLIDSZ
#define SLIDSZ 20
#endif

typedef struct
	{
	Window win;			/* an X window to parent all the others			*/
	Window topBar;		/* an X window to contain title line			*/
	int topSpace;		/* pixels used to hold the title 				*/

	Window infoBar;		/* an X window to hold the information line		*/
	int infSpace;		/* pixels used to hold the infoline				*/

	Window sidBar;		/* an X window to contain the vertical sliders	*/
	Window upArrow;		/* an X window for the 'scroll up' button		*/
	Window dnArrow;		/* an X window for the 'scroll down' button		*/
	int sideSpace;		/* X pixels used to hold the vert. slider		*/
	int sideHt;			/* height of the vertical slider				*/
	int sidStart;		/* slider position start (1->1000)				*/
	int sidPc;			/* slider position percentage (1->1000)			*/

	Window closer;		/* an X window used to hold the 'close' button	*/
	Window fuller;		/* an X window used to hold the 'full' button	*/

	Window botBar;		/* an X window to contain the horizontal sliders*/
	int botSpace;		/* Y pixels used to hold the horiz. slider		*/
	int botWd;			/* width of the horizontal slider				*/
	int botStart;		/* slider position start (1->1000)				*/
	int botPc;			/* slider position percentage (1->1000)			*/

	Window ltArrow;		/* an X window for the 'scroll left' button		*/
	Window rtArrow;		/* an X window for the 'scroll right' button	*/
	int rtArrX;			/* Offset along horiz slider of rt arrow		*/
	Window sizer;		/* an X window for the sizer box				*/
	int sizerX;			/* Offset along horiz slider of sizer			*/

	Window client;		/* an X window for the client to use			*/
	char name[1024];	/* text of window name							*/
	char icon[1024];	/* text of icon name							*/
	int x,y,w,h;		/* co-ordinates of the client window			*/
	int mx, my, mw, mh;	/* maximum co-ordinates of the client window	*/
	int ax, ay, aw, ah;	/* co-ordinates of the parent window			*/
	int px, py, pw, ph;	/* co-ordinates of the previous position		*/
	int bits;			/* the GEM-like bits that the window has		*/
	} Win;


#ifndef GEMwindMax
#define GEMwindMax 100
#endif
WWHERE int GEMcountW;				/* count of windows this app has open	*/
WWHERE Win GEMwins[GEMwindMax];		/* Number of windows an app has open	*/
WWHERE int GEMwinList[GEMwindMax];	/* The (global) order of wins			*/

#endif /* __WIND_H */
